//------------------------------------------------------
// PrintViewport3DVisual.cs (c) 2007 by Charles Petzold
//------------------------------------------------------
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace Petzold.PrintViewport3DVisual
{
    public partial class PrintViewport3DVisual
    {
        [STAThread]
        public static void Main()
        {
            Application app = new Application();
            app.Run(new PrintViewport3DVisual());
        }

        // Constructor.
        public PrintViewport3DVisual()
        {
            InitializeComponent();
        }

        // Event handlers for Print commands.
        void NormalPrintOnClick(object sender, RoutedEventArgs args)
        {
            PrintDialog dlg = new PrintDialog();

            if (dlg.ShowDialog().GetValueOrDefault())
            {
                dlg.PrintVisual(visual3d, "PrintViewport3DVisual: 3D Cube");
            }
        }

        void HiResPrintOnClick(object sender, RoutedEventArgs args)
        {
            PrintDialog dlg = new PrintDialog();

            if (dlg.ShowDialog().GetValueOrDefault())
            {
                Rect rect = visual3d.Viewport;

                // Scale dimensions from 96 dpi to 600 dpi.
                double scale = 600 / 96;

                RenderTargetBitmap bitmap = new RenderTargetBitmap((int) (scale * (rect.Width + 1)), 
                                                                   (int) (scale * (rect.Height + 1)), 
                                                                   scale * 96, 
                                                                   scale * 96, PixelFormats.Default);
                bitmap.Render(visual3d);

                // Create Image element for hosting bitmap.
                Image img = new Image();
                img.Source = bitmap;
                img.Stretch = Stretch.None;

                // Submit Image element to layout pass so it gets finite size.
                img.Measure(new Size(dlg.PrintableAreaWidth, 
                                     dlg.PrintableAreaHeight));
                Size sizeImage = img.DesiredSize;
                img.Arrange(new Rect(new Point(0, 0), sizeImage));

                // Print the Image element.
                dlg.PrintVisual(img, "PrintViewport3DVisual: 3D Cube");
            }
        }
    }
}
 